SuperStrict
'--------------------------------------
AppTitle = "Abstraktes Multi-Gemldepuzzle"
Global scx%, scy% 'die (variablen) Bildschirmabmessungen
'--------------------------------------
SeedRnd(MilliSecs())
Global timer:TTimer = CreateTimer(60)
'--------------------------------------
'Fr die globale Organisation der Benutzer-Interaktion:
Global MouseAction@[2], Mouse_X%, Mouse_Y%
Function UpdateMouse()
	If Animation = False Then
		Mouse_X = MouseX()
		Mouse_Y = MouseY()
		MouseAction[0] = MouseHit(1)
		MouseAction[1] = MouseHit(2)
	End If
End Function
'--------------------------------------
'Notwendig, falls neue Puzzlegroessen initialisiert werden:
Function ResizeWindow(new_scx%, new_scy%)
	If scx = new_scx And scy = new_scy Then Return
	scx = new_scx
	scy = new_scy
	Graphics scx, scy
	SetBlend ALPHABLEND
	SetClsColor 0,0,0
	SetMaskColor 127,128,129

	If MenuBackground <> Null Then 
		SetColor 128,128,128
		SetAlpha 1
		SetScale scx / Float(ImageWidth(MenuBackground)), scy / Float(ImageHeight(MenuBackground))
		DrawImage MenuBackground, 0, 0
		SetScale 1,1
		SetColor 0,0,0
		SetAlpha 0.7
		DrawRect 0.5*scx-180,scy/2-5, 360, 50
		SetColor 255,255,255
		SetAlpha 1
		SetImageFont(SmallFont)
		DrawText "Puzzle wird erstellt ...", scx/2-140, scy/2
		Flip
	End If
	
End Function
'--------------------------------------
'Sorgt fuer zufaellige Schichtung der Ebenen pro Puzzleteil:
Function Permutation%[](Count%)
	If Count <= 0 Then Return [0]
	Local i%, j%, MemoNumber%, ReturnValue%[Count]
	Count = Count - 1
	For i = 0 To Count
		ReturnValue[i] = i
	Next
	For i = Count To 1 Step -1
		Local Zufall:Int = Rand(0,i)
		MemoNumber = ReturnValue[i]
		ReturnValue[i] = ReturnValue[Zufall]
		If Zufall < i Then
			For j = Zufall To i - 1
				ReturnValue[j] = ReturnValue[j + 1]
			Next
			ReturnValue[i - 1] = MemoNumber
		End If
	Next
	Return ReturnValue
End Function
'--------------------------------------
'Zwei ausgelagerte Codes:
Include "PaintAbstractPicture.bmx"
Include "Menus.bmx"
'--------------------------------------
'Nun alles, was das Puzzle direkt angeht, seine Teile etc.
Global picture:TImage[] '(die Abbilder der "originalen" Gemlde)
Global tile:Ttile[], totalcount%, SelectedTile%, Animation@, size_modus@ = 1, puzzlecount%, puzzlecount_useroption% = 3
Global count_klicks%, needed_klicks%[], PuzzleStartTime%, Memo_ready@
'Mit dieser Funktion wird ein neues Puzzle geschaffen:
Function CreateTiles()

	Memo_ready = 0
	count_klicks = 0
	If puzzlecount_useroption = 3 Then
		puzzlecount% = Rand(3,5)
	Else
		puzzlecount = puzzlecount_useroption + 3
	End If
	Backgroundcolormode = GetNewRandomColorMode() 'alle sollen denselben haben...(!)
	Local countvertical%[]
	Select size_modus
	Case 0
		countvertical = [3,2,3]
		totalcount = 8
		ResizeWindow(560,480)
	Case 1
		countvertical = [4,3,4,3]
		totalcount = 14
		ResizeWindow(616,528)
	Case 2
		countvertical = [4,5,4,5,4,5]
		totalcount = 27
		ResizeWindow(756,560)
	Case 3
		countvertical = [5,6,5,6,5,6,5]
		totalcount = 38
		ResizeWindow(780,600)
	Case 4
		countvertical = [6,7,6,7,6,7,6,7]
		totalcount = 52
		ResizeWindow(832,672)
	Case 5
		countvertical = [7,8,7,8,7,8,7,8,7]
		totalcount = 67
		ResizeWindow(816,672)
	Case 6
		countvertical = [9,8,9,8,9,8,9,8,9,8]
		totalcount = 85
		ResizeWindow(850,720)
	Default '(7) biggest:
		countvertical = [10,9,10,9,10,9,10,9,10,9,10,9]
		totalcount = 114
		ResizeWindow(912, 720)
	End Select
	
	picture = New TImage[puzzlecount]
	needed_klicks = New Int[puzzlecount]
	tile = New Ttile[totalcount]
	For Local t% = 0 Until totalcount
		tile[t] = Ttile.Create()
	Next
	For Local pc% = 0 Until puzzlecount
		PaintAbstractPicture() 'das "Originalgemaelde" wird gemalt...
		picture[pc] = CreateImage(scx, scy)
		GrabImage(picture[pc], 0, 0)
		Local i%, temp_x%
		'Es folgt die weie Umrandung und das Abgreifen der einzelnen Teile,
		'was wegen der Asymmetrie der Aufteilung und Groesse NICHT einfach per LoadAnimImage funktioniert:
		For Local cv% = 0 Until Len(countvertical)
			Local size% = scy/countvertical[cv]
			Local temp_y%
			For Local j% = 0 Until countvertical[cv]
				DrawRect temp_x, temp_y,size,1
				DrawRect temp_x, temp_y,1,size
				DrawRect temp_x, temp_y+size-1,size,1
				DrawRect temp_x+size-1, temp_y,1,size
				tile[i].getimage(temp_x, temp_y, size, pc)
				i:+1
				temp_y:+size
			Next
			temp_x:+size
		Next
	Next
	SetColor 255,255,255
	SetClsColor 0,0,0
	SelectedTile = 0
	Animation = False
	help_time = MilliSecs()
	PuzzleStartTime = MilliSecs()
End Function
'--------------------------------------
'Das Zeichnen und interaktive Benutzen aller Puzzleteile:
Function DrawTiles@()
	For Local t% = 0 Until totalcount
		tile[t].draw(t)
	Next
	Local ready@ = tile[SelectedTile].drawselected()
	Return ready
End Function
'--------------------------------------
'Eine eigene Klasse fuer ein Puzzleteil:
Type Ttile

	Field img:TImage[], index%, permut%[], x%, y%, halfsize%, rotation%[], TurningTime%, RotatingTime%
	
	Function Create:Ttile()
		Local newtile:Ttile = New Ttile
		newtile.img = New TImage[puzzlecount]
		newtile.rotation = New Int[puzzlecount]
		newtile.permut = Permutation(puzzlecount)
		For Local i% = 1 Until Len(newtile.permut) 'nur ab 1 notwendig
			needed_klicks[newtile.permut[i]]:+i
		Next
		Return newtile
	End Function
	
	Method getimage(left_x%, top_y%, size%, temp_index%)
		halfsize = 0.5*size
		x = left_x + halfsize
		y = top_y + halfsize
		rotation[temp_index] = 90 * Rand(0,3)
		If rotation[temp_index] > 0 Then needed_klicks[temp_index] = needed_klicks[temp_index] + (360 - rotation[temp_index]) / 90
		img[temp_index] = CreateImage(size, size)
		GrabImage(img[temp_index], left_x, top_y)
		MidHandleImage(img[temp_index])
	End Method
	
	Method draw@(t%)
		If Animation = False Then
			If Abs(Mouse_X - x) >= halfsize Or Abs(Mouse_Y - y) >= halfsize Then
				SetRotation rotation[permut[index]]
				DrawImage img[permut[index]], x, y
			Else
				SelectedTile = t
			End If
		ElseIf SelectedTile <> t Then
			SetRotation rotation[permut[index]]
			DrawImage img[permut[index]], x, y
		End If
	End Method
	
	Method drawselected@()
		If RotatingTime <> 0 Then
			Local value# = (MilliSecs() - RotatingTime) / 250.0
			If value >= 1 Then
				For Local i% = 0 Until puzzlecount
					rotation[i] = (rotation[i]+90) Mod 360
				Next
				SetRotation rotation[permut[index]]
				DrawImage img[permut[index]], x, y
				RotatingTime = 0
				Animation = False
				Return TestReady()
			Else
				SetRotation rotation[permut[index]] + value*90
				DrawImage img[permut[index]], x, y
				SetScale 1, 1
			End If
			
		ElseIf TurningTime <> 0 Then
			'SetRotation 0
			Local value# = (MilliSecs() - TurningTime) / 250.0
			If value >= 1 Then
				index = (index + 1) Mod puzzlecount
				SetRotation rotation[permut[index]]
				DrawImage img[permut[index]], x, y
				TurningTime = 0
				Animation = False
				Return TestReady()
			ElseIf value < 0.5 Then
				SetRotation rotation[permut[index]]
				If rotation[permut[index]] Mod 180 = 0 Then
					SetScale 1 + 0.2 * value, 1 - 2*value
				Else
					SetScale 1 - 2*value, 1 + 0.2 * value
				End If
				SetColor 255 - value*400, 255 - value*400, 255 - value*400
				DrawImage img[permut[index]], x, y
				SetColor 255,255,255
				SetScale 1, 1
			Else
				Local new_index% = (index + 1) Mod puzzlecount
				SetRotation rotation[permut[new_index]]
				If rotation[permut[new_index]] Mod 180 = 0 Then
					SetScale 1.2 - 0.2*value, 2*(value-0.5)
				Else
					SetScale 2*(value-0.5), 1.2 - 0.2*value
				End If
				SetColor value*400-145, value*400-145, value*400-145
				DrawImage img[permut[new_index]], x, y
				SetColor 255,255,255
				SetScale 1, 1
			End If
		Else
			SetRotation rotation[permut[index]]
			DrawImage img[permut[index]], x, y
			If MouseAction[0] = True Then
				count_klicks:+1
				Animation = True
				RotatingTime = MilliSecs()
			End If
			If MouseAction[1] = True Then
				count_klicks:+1
				Animation = True
				TurningTime = MilliSecs()
			End If
		End If
	End Method
	
End Type
'--------------------------------------
'Hier wird getestet, ob eines der Gemaelde richtig zusammengesetzt wurde:
Function TestReady@()
	If tile[0].rotation[tile[0].permut[tile[0].index]] = 0 Then
		For Local i% = 1 Until totalcount
			If tile[i].permut[tile[i].index] <> tile[0].permut[tile[0].index] Or tile[i].rotation[tile[i].permut[tile[i].index]] <> 0 Then Return False
		Next
		Return True
	End If
End Function
'--------------------------------------
'(Nebensaechlich) die kurze Information, wie man wieder ins Menu kommt:
Function DrawStartInfoLine()
	If help_time <> 0 Then
		Local value# = (MilliSecs()-help_time)/3000.0
		If value < 1 Then
			If value < 0.7 Then
				value = 1.0
			Else
				value = (1.0 - value) / 0.3
			End If
			SetRotation 0
			SetAlpha 0.7*Value
			SetColor 0,0,0
			DrawRect 0.5*scx-242,scy/2-5, 480, 50
			SetAlpha value
			SetImageFont(SmallFont)
			SetColor 255,255,255
			DrawText "Zurck zum Hauptmenu mit " + Chr(34) + "Enter" + Chr(34), 0.5*scx-232,scy/2
			SetAlpha 1
		Else
			help_time = 0
		End If
	End If
End Function
'--------------------------------------
'Nun folgt das eigentliche Hauptprogramm und die Hauptschleife:
'--------------------------------------
ResizeWindow(616,528)
Global help_time%
Startmenu()
FlushMouse()
FlushKeys()
SetClsColor 255,255,255
Repeat
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
	
	If Memo_ready = False Then
		UpdateMouse()
		Cls
		Local ready@ = DrawTiles()
		DrawStartInfoLine()
		Flip
		WaitTimer(timer)
		If ready = True Then
			Memo_ready@ = True
			GratulationMenu()
			SetClsColor 255,255,255
			help_time = MilliSecs()
		End If

	Else 'If Memo_ready = True
		SetAlpha 1
		DrawImage picture[tile[0].permut[tile[0].index]], 0, 0
		DrawStartInfoLine()
		Flip
		WaitTimer(timer)
	End If
	
	If KeyHit(KEY_RETURN) > 0 Then
		Startmenu()
		FlushMouse()
		FlushKeys()
		SetClsColor 255,255,255
		help_time = MilliSecs()
	End If
		
Forever