'Die Schriftarten laden, zwei Groessen:
Global Smallfont:TImageFont = LoadImageFont("media/freefont/ChopinScript.otf", 36)
Global Bigfont:TImageFont = LoadImageFont("media/freefont/ChopinScript.otf", 90)
'Einige Schalterbilder
Global ButtonImage:TImage = LoadImage("media/images/button.png")
SetImageHandle(ButtonImage, 155, 8)
Global OptionButtonImage0:TImage = LoadAnimImage("media/images/optionbutton0.png", 50, 75, 0,16)
Global OptionButtonImage1:TImage = LoadAnimImage("media/images/optionbutton1.png", 50, 75, 0,8)
'und das kleine Signal, wenn das Puzzle fertig ist:
Global VictorySound:TSound = LoadSound("media/sounds/Victory.ogg")

'Ein Mittelding zwischen einer Buttonklasse und einer erweiterten Textanzeige:
Type TActivText
	Field text$, x%, y%, width%, height%, passiv@, big@
	Function Create:TActivText(text$, y%, big@ = False, passiv@ = False)
		Local NewActivText:TActivText = New TActivText
		NewActivText.text = text
		NewActivText.big = big
		NewActivText.passiv = passiv
		If big = False Then
			SetImageFont SmallFont
		Else
			SetImageFont BigFont
		End If
		NewActivText.width = TextWidth(text)
		NewActivText.height = TextHeight(text)
		NewActivText.x = 0.5 * (scx - NewActivText.width)
		NewActivText.y = y
		Return NewActivText
	End Function
	
	Method Draw@()
		If big = False Then
			SetImageFont SmallFont
		Else
			SetImageFont BigFont
		End If
		If passiv = False Then
			SetColor 255,255,255
			If Mouse_X < scx/2-155 Or Mouse_Y < y-8 Or Mouse_X > scx/2+155 Or Mouse_Y > y + 48 Then
				SetAlpha 0.5
				DrawImage ButtonImage, scx/2, y
				SetColor 0,0,0
				DrawText text,x+1,y+1
				SetAlpha 0.8
				SetColor 255,255,255
				DrawText text, x, y
			Else
				SetAlpha 1
				DrawImage ButtonImage, scx/2, y
				SetColor 0,0,0
				DrawText text,x+1,y+1
				SetColor 255,255,255
				DrawText text, x, y
				If MouseAction[0] = True Or MouseAction[1] = True Then Return True
			End If
		Else
			SetAlpha 0.8
			SetColor 0,0,0
			DrawText text,x+2, y+2
			SetAlpha 1.0
			SetColor 255,255,255
			DrawText text, x, y
		End If
	End Method
End Type

Global MenuBackground:TImage

'Das Hauptmenu:
Function Startmenu()
	Backgroundcolormode = GetNewRandomColorMode()
	PaintAmbientBackground()
	MenuBackground = Null
	MenuBackground = CreateImage(scx, scy)
	GrabImage(MenuBackground, 0, 0)
	SetRotation 0
	SetScale 1,1
	'--------------------------
	Local title:TActivText = TActivText.Create("Candy 'n Sky", 0.5*scy - 200, True, True)
	Local top_y% = 0.5*scy-62
	Local backbutton:TActivText
	If tile <> Null Then
		backbutton = TActivText.Create("Zurck zum Puzzle", top_y)
		top_y:+60
	End If
	Local startbutton:TActivText = TActivText.Create("Neues Puzzle erstellen", top_y)
	top_y:+60
	Local helpbutton:TActivText = TActivText.Create("Spielanleitung lesen", top_y)
	top_y:+60
	Local optionenbutton:TActivText = TActivText.Create("Optionen auswhlen", top_y)
	top_y:+60
	Local creditsbutton:TActivText = TActivText.Create("Copyrights lesen", top_y)
	'---------------------------
	UpdateMouse()
	Local StopStartmenu@ = False
	Repeat
		SetColor 128,128,128
		SetAlpha 1
		DrawImage MenuBackground, 0, 0
		title.draw()
		If backbutton <> Null Then
			If backbutton.draw() = True Then
				StopStartmenu = True
			End If
		End If
		If startbutton.draw() = True Then
			SetColor 128,128,128
			SetAlpha 1
			DrawImage MenuBackground, 0, 0
			SetColor 0,0,0
			SetAlpha 0.7
			DrawRect 0.5*scx-180,scy/2-5, 360, 50
			SetColor 255,255,255
			SetAlpha 1
			DrawText "Puzzle wird erstellt ...", scx/2-140, scy/2
			Flip
			CreateTiles()
			Return
		End If
		If helpbutton.draw() = True Then
			Helpmenu()
		End If
		If optionenbutton.draw() = True Then
			If OptionsMenu() = True Then Return
		End If
		If creditsbutton.draw() = True Then
			CreditsMenu()
		End If
		UpdateMouse()
		Flip
		WaitTimer(timer)
		If KeyDown(KEY_ESCAPE) Or AppTerminate() = True Then End
	Until StopStartmenu = True
End Function

'Das Menu, wenn das Puzzle fertig ist:
Function GratulationMenu()
	SetRotation 0
	SetScale 1,1
	'--------------------------
	Local title:TActivText = TActivText.Create("Gratulation!", 0.5*scy - 200, True, True)
	Local info:TActivText[2], top_y% = 0.5*scy-70
	info[0] = TActivText.Create( "In " + ((MilliSecs()-PuzzleStartTime) / 1000) + " Sekunden und " + count_klicks + " Schritten gelst.", top_y, False, True)
	top_y:+60
	info[1] = TActivText.Create("Notwendig waren minimal  " + needed_klicks[tile[0].permut[tile[0].index]] + " Schritte.", top_y, False, True)
	top_y:+85
	Local startbutton:TActivText = TActivText.Create("Neues Puzzle erstellen", top_y)
	top_y:+80
	Local mainmenubutton:TActivText = TActivText.Create("Zurck zum Haupmenu", top_y)
	PlaySound(VictorySound)
	UpdateMouse()
	'---------------------------
	Local GratulationTime% = MilliSecs()
	Repeat
		Local backgroundbrightness% = Max(128, 255 - 155.0*(MilliSecs()-GratulationTime) / 4000.0)
		SetColor backgroundbrightness, backgroundbrightness, backgroundbrightness
		SetAlpha 1
		DrawImage picture[tile[0].permut[tile[0].index]], 0, 0
		title.draw()
		info[0].draw()
		info[1].draw()
		If startbutton.draw() = True Then
			SetColor 128,128,128
			SetAlpha 1
			DrawImage MenuBackground, 0, 0
			SetColor 0,0,0
			SetAlpha 0.7
			DrawRect 0.5*scx-180,scy/2-5, 360, 50
			SetColor 255,255,255
			SetAlpha 1
			DrawText "Puzzle wird erstellt ...", scx/2-140, scy/2
			Flip
			CreateTiles()
			Return
		End If
		If mainmenubutton.draw() = True Then
			Startmenu()
			Return
		End If
		UpdateMouse()
		Flip
		WaitTimer(timer)
		If KeyDown(KEY_ESCAPE) Or AppTerminate() = True Then End
	Forever
End Function

'Das Menu fuer die kleine Spielanleitung mit den wichtigsten Infos:
Function HelpMenu()
	'--------------------------
	Local info:TActivText[8], top_y% = 0.5*scy-220
	info[0] = TActivText.Create("Alle Puzzleteile liegen schon an der richtigen", top_y, False, True)
	top_y:+45
	info[1] = TActivText.Create("Stelle, sind aber verdreht und gehren zu ver-", top_y, False, True)
	top_y:+45
	info[2] = TActivText.Create("schiedenen abstrakten " + Chr(34) + "Gemlden" + Chr(34) + ". Mit der", top_y, False, True)
	top_y:+45
	info[3] = TActivText.Create("rechten Maustaste kann man die Teile um-", top_y, False, True)
	top_y:+45
	info[4] = TActivText.Create("klappen und ihre Gemlde-Ebene wechseln.", top_y, False, True)
	top_y:+45
	info[5] = TActivText.Create("Mit der linken Maustaste dreht man sie.", top_y, False, True)
	top_y:+45
	info[6] = TActivText.Create("Es gilt, in mglichst wenigen Schritten eines", top_y, False, True)
	top_y:+45
	info[7] = TActivText.Create("der mglichen Gemlde zusammenzulegen.", top_y, False, True)
	top_y:+70
	Local backbutton:TActivText = TActivText.Create("Zurck zum Haupmenu", top_y)
	'---------------------------
	UpdateMouse()
	Local StopStartmenu@ = False
	Repeat
		SetColor 128,128,128
		SetAlpha 1
		DrawImage MenuBackground, 0, 0
		For Local hi% = 0 Until Len(info)
			info[hi].draw()
		Next
		If backbutton.draw() = True Then StopStartmenu = True
		UpdateMouse()
		Flip
		WaitTimer(timer)
		If KeyDown(KEY_ESCAPE) Or AppTerminate() = True Then End
	Until StopStartmenu = True
End Function

'Die Urheber-Informationen:
Function CreditsMenu()
	'--------------------------
	Local info:TActivText[8], top_y% = 0.5*scy-220
	info[0] = TActivText.Create("Dieses abstrakte Puzzleprogramm wurde von", top_y, False, True)
	top_y:+45
	info[1] = TActivText.Create("Udo Kinast programmiert und entwickelt mit", top_y, False, True)
	top_y:+45
	info[2] = TActivText.Create("BlitzMax, PaintShopPro, Garageband.", top_y, False, True)
	top_y:+45
	info[3] = TActivText.Create("Das Freefont " + Chr(34) + "Chopinscript" + Chr(34) + " ist " + Chr(34) + "Public", top_y, False, True)
	top_y:+45
	info[4] = TActivText.Create("domain" + Chr(34) + " unter www.dafont.com zu finden.", top_y, False, True)
	top_y:+45
	info[5] = TActivText.Create("Das Puzzleprogramm ist Freeware und", top_y, False, True)
	top_y:+45
	info[6] = TActivText.Create("darf nicht kommerziell missbraucht werden.", top_y, False, True)
	top_y:+45
	info[7] = TActivText.Create("Viel Spa!", top_y, False, True)
	top_y:+70
	Local backbutton:TActivText = TActivText.Create("Zurck zum Haupmenu", top_y)
	'---------------------------
	UpdateMouse()
	Local StopStartmenu@ = False
	Repeat
		SetColor 128,128,128
		SetAlpha 1
		DrawImage MenuBackground, 0, 0
		For Local hi% = 0 Until Len(info)
			info[hi].draw()
		Next
		If backbutton.draw() = True Then StopStartmenu = True
		UpdateMouse()
		Flip
		WaitTimer(timer)
		If KeyDown(KEY_ESCAPE) Or AppTerminate() = True Then End
	Until StopStartmenu = True
End Function

'Das kurze Menu zu den waehlbaren Optionen:
Function OptionsMenu@()
	SetRotation 0
	SetScale 1,1
	Local old_size_modus@ = size_modus
	'--------------------------
	Local info:TActivText[2], top_y% = 0.5*scy-225
	info[0] = TActivText.Create( "Puzzlegre, Anzahl der Puzzleteile:", top_y, False, True)
	top_y:+160
	info[1] = TActivText.Create("Anzahl der Gemlde-Ebenen:", top_y, False, True)
	top_y:+180
	Local startbutton:TActivText = TActivText.Create("Neues Puzzle erstellen", top_y)
	top_y:+65
	Local mainmenubutton:TActivText = TActivText.Create("Zurck zum Haupmenu", top_y)
	UpdateMouse()
	'---------------------------
	Repeat
		SetColor 128,128,128
		SetAlpha 1
		DrawImage MenuBackground, 0, 0
		'--------------------------------------------------
		info[0].draw()
		info[1].draw()
		'--------------------------------------------------
		SetAlpha 0.6
		For Local b% = 0 Until 8
			Local temp_x% = scx/2 - 235 + b*60
			If b = size_modus Then
				SetAlpha 1
				DrawImage OptionButtonImage0, scx/2 - 235 + b*60, info[0].y + 60, b+8
				SetAlpha 0.6
			ElseIf Mouse_Y < info[0].y + 60 Or Mouse_Y > info[0].y + 135 Or Mouse_X < temp_x Or Mouse_X > temp_x + 50 Then
				DrawImage OptionButtonImage0, temp_x, info[0].y + 60, b
			Else
				SetAlpha 1
				DrawImage OptionButtonImage0, temp_x, info[0].y + 60, b
				SetAlpha 0.6
				If MouseAction[0] > 0 Or MouseAction[1] > 0 Then size_modus = b
			End If
		Next
		'-------------------------------------------------
		For Local c% = 0 Until 4
			Local temp_x% = scx/2 - 115 + c*60
			If c = puzzlecount_useroption Then
				SetAlpha 1
				DrawImage OptionButtonImage1, scx/2 - 115 + c*60, info[1].y + 60, c+4
				SetAlpha 0.6
			ElseIf Mouse_Y < info[1].y + 60 Or Mouse_Y > info[1].y + 135 Or Mouse_X < temp_x Or Mouse_X > temp_x + 50 Then
				DrawImage OptionButtonImage1, temp_x, info[1].y + 60, c
			Else
				SetAlpha 1
				DrawImage OptionButtonImage1, temp_x, info[1].y + 60, c
				SetAlpha 0.6
				If MouseAction[0] > 0 Or MouseAction[1] > 0 Then puzzlecount_useroption = c
			End If
		Next
		'---------------------------------------------------
		If startbutton.draw() = True Then
			If old_size_modus = size_modus Then
				SetColor 128,128,128
				SetAlpha 1
				DrawImage MenuBackground, 0, 0
				SetColor 0,0,0
				SetAlpha 0.7
				DrawRect 0.5*scx-180,scy/2-5, 360, 50
				SetColor 255,255,255
				SetAlpha 1
				DrawText "Puzzle wird erstellt ...", scx/2-140, scy/2
				Flip
			End If
			CreateTiles()
			Return True
		End If
		If mainmenubutton.draw() = True Then
			UpdateMouse()
			Return False
		End If
		UpdateMouse()
		Flip
		WaitTimer(timer)
		If KeyDown(KEY_ESCAPE) Or AppTerminate() = True Then End
	Forever
End Function
