'Hier geht es um die kleine bescheidene Simulation von Kandinskys abstrakten Gemaelden:
'-----------------------------------------------------------------------------------------------------------------
'Zunaechst die unterschiedlichen Bildelemente bzw. Motive:
Const CountAllMotifs% = 47
Global MotifImage:TImage[CountAllMotifs]
Global MotifWidth%[CountAllMotifs], MotifHeight%[CountAllMotifs]
Global ControlledColorMode%[3], deforming_Motifs@, rotating_Motifs@
For Local motif_index% = 0 Until CountAllMotifs
	MotifImage[motif_index] = LoadImage("media/images/Motif-" + motif_index + ".png")
	MotifWidth[motif_index] = ImageWidth(MotifImage[Motif_index])
	MotifHeight[motif_index] = ImageHeight(MotifImage[Motif_index])
	MidHandleImage(MotifImage[motif_index])
Next
Global Mist:TImage = LoadImage("media/images/Mist.png")
MidHandleImage(Mist)
Global Backgroundcolormode%[] = GetNewRandomColorMode()
'-----------------------------------------------------------------------------------------------------------------
'Der weiche fluessige Hintergrund:
Function PaintAmbientBackground()
	ControlledColorMode = Backgroundcolormode
	SetReducedRandomClsColor(0,64)
	Local distance% = 142
	Local y%, x% = 0.5*(scx Mod distance)
	Repeat
		y = 0.5*(scy Mod distance)
		Repeat
			SetReducedRandomColor(32,255)
			SetAlpha 0.5 + Rnd()
			SetScale 0.1+ 2*Rnd(), 0.1 + 2*Rnd()
			SetRotation Rand(0,359)
			DrawImage Mist, x + Rand(-0.5*distance,0.5*distance), y + Rand(-0.5*distance,0.5*distance)
			y:+distance
		Until y > scy
		x:+distance
	Until x > scx
End Function

'Das Komponieren der Motive, der Groesse nach gestaffelt nach Vorder- und Hintergrund:
'Die eingeschraenkte Zufalls-Positionierung sorgt dafuer, dass ueber dem ganzen Bild-
'schirm verteilt markante Motive zu finden sind und sich keine "leere" Luecke ergibt, welche
'fuer die Zusammensetzung eines Puzzles nicht genuegend Anhaltspunkte geben wuerde:
Function PaintAbstractPicture()
	'Den farblich nicht zu aufdringligen 'Hintergrund' malen:
	PaintAmbientBackground()
	'----------------------------------------------------------------
	'als erstes ein paar grosse Dinge:
	rotating_Motifs = False 'Rand(0,1)
	deforming_Motifs = False 'Rand(0,2)
	SetBlendMode(1)
	Local distance% = 284
	Local y%, x% = 0.5*(scx Mod distance)
	Repeat
		y = 0.5*(scy Mod distance)
		Repeat
			SetReducedRandomColor(0,255)
			PaintMotif(x + Rand(-0.25*distance,0.25*distance), y + Rand(-0.25*distance,0.25*distance), Rand(0,15), 1.5)
			y:+distance
		Until y > scy
		x:+distance
	Until x > scx
	'----------------------------------------------------------------
	'Dann eins, zwei (evtl. individuellere) Formen mit neuer Farbgebung

	SetBlendMode(0)
	rotating_Motifs = Rand(0,1)
	deforming_Motifs = Rand(0,2)
	SetReducedRandomColor(32,255)
	PaintMotif(0.333333*scx + Rand(-scx/6.0, scx/6.0), scy/2.0 + Rand(-scy/4.0, scy/4.0), Rand(0,27), 1.5)
	rotating_Motifs = Rand(0,1)
	deforming_Motifs = Rand(0,2)
	SetReducedRandomColor(32,255)
	PaintMotif(0.666666*scx + Rand(-scx/6.0, scx/6.0), scy/2.0 + Rand(-scy/4.0, scy/4.0), Rand(0,27), 1.5)
	
	
	'----------------------------------------------------------------
	'dann viele kleine Dinge verstreut
	Local selected_motifindex%[] = [Rand(0,27), Rand(0,27), Rand(0,27), Rand(0,27)]
	distance = 142
	x = 0
	Repeat
		y = 0
		Repeat
			SetBlendMode(Rand(0,2))
			rotating_Motifs = Rand(0,1)
			deforming_Motifs = Rand(0,2)
			SetReducedRandomColor(0,255)
			PaintMotif(x + Rand(-0.25*distance,0.25*distance), y + Rand(-0.25*distance,0.25*distance), selected_motifindex[Rand(0,3)], 0.5)
			y:+distance
		Until y > scy
		x:+distance
	Until x > scx
	'----------------------------------------------------------------

	'dann die bekannten Linien:
	SetBlendMode(0)
	rotating_Motifs = True
	deforming_Motifs = 1
	distance = Rand(284, 426)
	x =  scx Mod distance
	Repeat
		y = scy Mod distance
		Repeat
			SetReducedRandomColor(0,255)
			PaintMotif(x + Rand(-0.25*distance,0.25*distance), y + Rand(-0.25*distance,0.25*distance), Rand(28,29), 1.0)
			y:+distance
		Until y > scy
		x:+distance
	Until x > scx

	'zum Schluss noch zwei besondere Linien:
	PaintMotif(0.333333*scx + Rand(-scx/6.0, scx/6.0), scy/2.0 + Rand(-scy/4.0, scy/4.0), Rand(30,46), 1.0)
	PaintMotif(0.666666*scx + Rand(-scx/6.0, scx/6.0), scy/2.0 + Rand(-scy/4.0, scy/4.0), Rand(30,46), 1.0)
	'---------------
	SetBlend ALPHABLEND
	SetAlpha 1
	SetRotation 0
	SetScale 1,1
	SetColor 255,255,255
	'---------------
End Function
'---------------------------------------------------------------
Function SetBlendMode(mode%)
	If mode = 2 Then
		SetBlend LIGHTBLEND
		SetAlpha 1.0
	Else
		SetBlend ALPHABLEND
		If mode < 1 Then
			SetAlpha 1.0
		Else
			SetAlpha 0.5
		End If
	End If
End Function
'---------------------------------------------------------------
'Hier wird dafuer gesorgt, dass die Vielfalt der zufaelligen Farben eingeschraenkt
'wird, damit es nicht allzu "bunt", sondern einheitlicher wird und sich von Gemaelder
'zu Gemaelder eher unterscheidet:
Function GetNewRandomColorMode%[]()
	If Rand(0,1) = 0 Then
		Local Random% = Rand(0,5)
		Select Random
		Case 0
			Return [1,2,0]
		Case 1
			Return [1,0,2]
		Case 2
			Return [0,1,2]
		Case 3
			Return [1,1,2]
		Case 4
			Return [1,2,1]
		Default
			Return [2,1,1]
		End Select
	Else
		Local Random% = Rand(0,11)
		Select Random
		Case 0
			Return [1,3,0]
		Case 1
			Return [1,0,3]
		Case 2
			Return [0,1,3]
		Case 3
			Return [3,1,0]
		Case 4
			Return [3,0,1]
		Case 5
			Return [0,3,1]
		Case 6
			Return [1,1,3]
		Case 7
			Return [1,3,1]
		Case 8
			Return [3,1,1]
		Case 9
			Return [3,3,0]
		Case 10
			Return [3,0,3]
		Default '11
			Return [0,3,3]
		End Select
	End If
End Function
'---------------------------------------------------------------
'Das Ausfuehren der eingeschraenkten Zufallsfarben:
Function SetReducedRandomColor(lowest%, highest%)
	Local RGB%[3], Colordepth% = Rand(lowest, highest)
	For Local i% = 0 To 2
		Select ControlledColorMode[i]
		Case 0
			RGB[i] = 0
		Case 1
			RGB[i] = Colordepth
		Case 2
			RGB[i] =  lowest + highest - Colordepth
		Default	 'Case 3
			RGB[i] = Rand(lowest, highest)
		End Select
	Next
	SetColor RGB[0], RGB[1], RGB[2]
End Function
'---------------------------------------------------------------
'Ebenso fuer den Hintergrund
Function SetReducedRandomClsColor(lowest%, highest%)
	Local RGB%[3], Colordepth% = Rand(lowest, highest)
	For Local i% = 0 To 2
		Select ControlledColorMode[i]
		Case 0
			RGB[i] = 0
		Case 1
			RGB[i] = Colordepth
		Case 2
			RGB[i] = lowest + highest - Colordepth
		Default	 'Case 3
			RGB[i] = Rand(lowest, highest)
		End Select
	Next
	SetClsColor RGB[0], RGB[1], RGB[2]
	Cls
End Function
'---------------------------------------------------------------
'Das formatierte Zeichnen der einzelnen Motive:
Function PaintMotif(x%, y%, reduced_random_index%, scale_orientation#)
	' - - - -
	If deforming_Motifs = True Then
		SetScale 0.5 * scale_orientation + Rnd()*scale_orientation, 0.5 * scale_orientation + Rnd()*scale_orientation
	Else
		Local scale# = 0.5 * scale_orientation + Rnd()*scale_orientation
		SetScale scale, scale
	End If
	' - - - -
	Local rotation%
	If rotating_Motifs = False Then
		rotation = Rand(0,3)*90
	Else
		rotation = 360 * Rnd()
	End If
	SetRotation rotation
	' - - - -
	SetReducedRandomColor(32,255)
	' - - - -
	DrawImage MotifImage[reduced_random_index], x, y
	' - - - -
End Function