; <!--- TEXT / FONT

Const MAX_FONT_SIZE = 42
Global FONT_ARRAY[MAX_FONT_SIZE]

Function LoadFonts(s$)
	; ok srsly, why the fuck does "graphics" kill my fonts? STOP IT >:O
	
	For i = 10 To MAX_FONT_SIZE
		FONT_ARRAY[i] = LoadFont(s, i)
	Next
End Function

Function SetTextSize(i)
	SetFont( FONT_ARRAY[i] )
End Function

Function CenterText(s$, y)
	Text (GraphicsWidth() - StringWidth(s)) /2, y, s
End Function

Function manipulateText$(s$)
	Local key = GetKey()
	
	If key <> 0
		If key = 8
			If Len(s) >= 1
				s = Left(s, Len(s) -1)
			EndIf
		Else
			s = s + Chr(key)
		EndIf
	EndIf
	
	Return s
End Function

; FONT / TEXT ---!>

; <!--- GameState (History)

Const MAX_SIZE = 50

Global SIZE = 5
Global TILESIZE = 50
Dim dat(SIZE, SIZE)

Type GameState
	Field gData[MAX_SIZE * MAX_SIZE]
End Type

Function newGameState.GameState()
	Local g.GameState = New GameState
	
	For i = 0 To SIZE -1
		For j = 0 To SIZE -1
			g\gData[j * SIZE + i] = dat(i, j)
		Next
	Next
	
	Return g
End Function

Function restoreGameState(g.GameState)
	For i = 0 To SIZE -1
		For j = 0 To SIZE -1
			dat(i, j) = g\gData[j * SIZE + i]
		Next
	Next
End Function

; GameState ---!>

; <!--- Game Environment

Global IMG_PATH$ = "BackGround.jpg"
Global img

Global GAME_MODE = 0

Function init()
	For i = 0 To SIZE -1
		For j = 0 To SIZE -1
			dat(i, j) = j * SIZE + i + 1
		Next
	Next
	
	dat(SIZE -1, SIZE -1) = 0
End Function

Function shuffle()
	Local x0, y0
	
	For k = 0 To (SIZE * SIZE) ^2
		For i = 0 To SIZE -1
			For j = 0 To SIZE -1
				If dat(i, j) = 0
					x0 = i
					y0 = j
				EndIf
			Next
		Next
		
		If Rand(0, 1) = 0
			x = Rand(0, SIZE -1)
			y = y0
			
			play(x, y)
		Else
			x = Rand(0, SIZE -1)
			y = x0
			
			play(x, y)
		EndIf
	Next
End Function

Function draw()
	Local TX
	Local TY
	
	SetTextSize(12)
	
	For i = 0 To SIZE -1
		For j = 0 To SIZE -1
			If dat(i, j) <> 0
				TX = i * TILESIZE
				TY = j * TILESIZE
				
				Color 200, 200, 200
				Rect TX, TY, TILESIZE, TILESIZE
				
				If GAME_MODE = 0
					Color 0, 0, 0
					Rect TX, TY, TILESIZE, TILESIZE, 0
					Text TX + TILESIZE /2 -StringWidth(dat(i, j)) /2, TY + TILESIZE /2 -FontHeight()/2, dat(i, j)
				Else
					x = ((dat(i, j) -1) Mod SIZE)
					y = ((dat(i, j) -1) / SIZE)
					DrawBlockRect img, TX, TY, x * TILESIZE, y * TILESIZE, TILESIZE, TILESIZE
					
					If x = i And y = j
						Color 255, 255, 0
						
						For k = 0 To 1
							Rect TX +k, TY +k, TILESIZE -k *2, TILESIZE -k *2, 0
						Next
					EndIf
				EndIf
			EndIf
		Next
	Next
End Function

Function play(x, y)
	Local x0, y0
	
	For i = 0 To SIZE -1
		For j = 0 To SIZE -1
			If dat(i, j) = 0
				x0 = i
				y0 = j
			EndIf
		Next
	Next
	
	If x = x0
		If y < y0
			For i = y0 To y +1 Step -1
				dat(x, i) = dat(x, i -1)
			Next
			
			dat(x, y) = 0
		ElseIf y > y0
			For i = y0 To y -1
				dat(x, i) = dat(x, i +1)
			Next
			
			dat(x, y) = 0
		Else
			;DebugLog "wrong!"
			Return False
		EndIf
	ElseIf y = y0
		If x < x0
			For i = x0 To x +1 Step -1
				dat(i, y) = dat(i -1, y)
			Next
			
			dat(x, y) = 0
		ElseIf x > x0
			For i = x0 To x -1
				dat(i, y) = dat(i +1, y)
			Next
			
			dat(x, y) = 0
		Else
			;DebugLog "wrong!"
			Return False
		EndIf
	Else
		;DebugLog "wrong!"
		Return False
	EndIf
	
	Return True
End Function

Function checkVictory()
	Local victory = True
	
	For i = 0 To SIZE -1
		For j = 0 To SIZE -1
			If Not (i = SIZE -1 And j = SIZE -1)
				If Not dat(i, j) = j * SIZE + i + 1
					victory = False
				EndIf
			EndIf
		Next
	Next
	
	Return victory
End Function

; Game Environment ---!>

Function menu()
	Graphics 640, 480, 0, 2
	SetBuffer BackBuffer()
	
	Local timer = CreateTimer(60)
	
	LoadFonts("")
	
	Local actManipulation = -1
	
	While True
		Color 255, 255, 255
		
		If KeyHit(1)
			Return
		EndIf
		
		SetTextSize(42)
		CenterText("SchiebePuzzle", 15)
		
		SetTextSize(22)
		CenterText("Game Size:", 120)
		CenterText("Game Mode:", 180)
		CenterText("Game Image:", 240)
		CenterText("Tile Size:", 300)
		
		SetTextSize(18)
		CenterText(SIZE, 150)
		If GAME_MODE = 0
			CenterText("Numbers", 210)
		Else
			CenterText("Image", 210)
		EndIf
		CenterText(IMG_PATH, 270)
		CenterText(TILESIZE, 330)
		
		If MouseHit(1)
			actManipulation = -1
			
			For i = 0 To 3
				If RectsOverlap(MouseX(), MouseY(), 1, 1, 0, 150 +i *60, GraphicsWidth(), 18)
					actManipulation = i
				EndIf
			Next
			
			If actManipulation = 1
				GAME_MODE = 1 - GAME_MODE
				
				actManipulation = -1
			EndIf
			
			FlushKeys()
			
			If RectsOverlap(MouseX(), MouseY(), 1, 1, 0, 400, GraphicsWidth(), 80)
				game()
			EndIf
		EndIf
		If KeyHit(28)
			If actManipulation = -1
				game()
			Else
				actManipulation = -1
			EndIf
		EndIf
		
		Select actManipulation
			Case 0
				SIZE = Int( manipulateText(SIZE) )
				Text (GraphicsWidth() + StringWidth(SIZE)) /2, 150, "_"
			Case 2
				IMG_PATH = manipulateText(IMG_PATH)
				Text (GraphicsWidth() + StringWidth(IMG_PATH)) /2, 270, "_"
			Case 3
				TILESIZE = Int( manipulateText(TILESIZE) )
				Text (GraphicsWidth() + StringWidth(TILESIZE)) /2, 330, "_"
		End Select
		
		SetTextSize(28)
		CenterText("<START GAME>", 400)
		
		Flip 0
		WaitTimer(timer)
		Cls
	Wend
	
	Return
End Function

Function game()
	Graphics SIZE * TILESIZE, SIZE * TILESIZE, 0, 2
	Graphics SIZE * TILESIZE, SIZE * TILESIZE, 0, 3
	SetBuffer BackBuffer()
	SeedRnd( MilliSecs() )
	
	LoadFonts("")
	
	Local timer = CreateTimer(60)
	
	Local gStack.GameState
	Local tmpStack1.GameState
	Local tmpStack2.GameState
	
	img = 0
	If FileType(IMG_PATH) <> 0
		img = LoadImage(IMG_PATH)
		ResizeImage img, GraphicsWidth(), GraphicsHeight()
	EndIf
	
	init()
	shuffle()
	
	gStack = newGameState()
	
	While Not KeyHit(1)
		draw()
		
		If MouseHit(1)
			xTile = MouseX() /TILESIZE
			yTile = MouseY() /TILESIZE
			
			If play(xTile, yTile)
				tmpStack1 = After gStack
				While tmpStack1 <> Null
					tmpStack2 = tmpStack1
					tmpStack1 = After tmpStack1
					
					Delete tmpStack2
				Wend
				
				gStack = newGameState()
			EndIf
		EndIf
		
		If KeyHit(21)
			If Before gStack <> Null
				gStack = Before gStack
				
				restoreGameState(gStack)
			EndIf
		EndIf
		If KeyHit(20)
			If After gStack <> Null
				gStack = After gStack
				
				restoreGameState(gStack)
			EndIf
		EndIf
		
		If MouseHit(2)
			GAME_MODE = 1 - GAME_MODE
		EndIf
		If img = 0
			GAME_MODE = 0
		EndIf
		
		If checkVictory()
			Color 255, 0, 0
			SetTextSize(40)
			
			CenterText("VICTORY", (GraphicsHeight() -FontHeight())/2)
		EndIf
		
		Flip 0
		WaitTimer(timer)
		Cls
	Wend
	
	Delete Each GameState
	
	Graphics 640, 480, 0, 2
	SetBuffer BackBuffer()
	LoadFonts("")
	
	Return
End Function

Function credits()
	Local timer = CreateTimer(60)
	
	i = 500
	
	While Not KeyHit(1)
		SetTextSize(32)
		CenterText("Game Idea", i)
		CenterText("Idea to steal the Idea", i +150)
		CenterText("Head of Programming", i +300)
		CenterText("Head of Graphics", i +450)
		CenterText("Actual Graphics", i +600)
		CenterText("Head of Sound", i +750)
		CenterText("Actual Sound", i +900)
		CenterText("What else is there?", i +1050)
		
		SetTextSize(18)
		CenterText("no clue..", i +40)
		CenterText("Darth", i +190)
		CenterText("Darth", i +340)
		CenterText("Darth", i +490)
		CenterText("Stolen.. of course", i +640)
		CenterText("Darth", i +790)
		CenterText("Sadly.. none", i +940)
		CenterText("Nothing, we're done now", i +1090)
		
		i = i -1
		
		If i < -1250
			Return
		EndIf
		
		Flip 0
		WaitTimer(timer)
		Cls
	Wend
	End
End Function

; <!--- START \o/

menu()
credits()
End

; ---!>
;~IDEal Editor Parameters:
;~C#Blitz3D